#!/bin/bash

# -------------------------------------------------------------------------- #
# Copyright 2002-2021, OpenNebula Project, OpenNebula Systems                #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

#rbt: brest mode
DRIVER_PATH=$(dirname $0)
if [ "$ONE_BREST_MODE" == "1" ] && [ "$SVMBREST" != "1" ]; then #rbt

    $DRIVER_PATH/cancel_brest $@

else

    source $(dirname $0)/../../etc/vmm/kvm/kvmrc
    source $(dirname $0)/../../scripts_common.sh

    deploy_id=$1

    TIMEOUT=60

    #rbt: vgpu
    HOST=$2
    VM_ID=$3

    if [ "$ONE_BREST_MODE" == "1" ]; then
        LIBVIRT_URI=qemu+ssh://$HOST/system #rbt
    fi

    function destroy_and_monitor
    {
        virsh --connect $LIBVIRT_URI --readonly dominfo $deploy_id > /dev/null 2>&1 || return 0

        virsh --connect $LIBVIRT_URI destroy $deploy_id

        #rbt: vgpu, BREST-4002
        # Destroy vGPU for VM HA
        $DRIVER_PATH/vgpu_brest "DELETE" "$VM_CONF_DIR/$VM_ID/vm.xml" "$HOST"

        virsh --connect $LIBVIRT_URI --readonly dominfo $deploy_id > /dev/null 2>&1
        [ "x$?" != "x0" ]
    }

    retry $TIMEOUT destroy_and_monitor

    if [ "x$?" != "x0" ]; then
        error_message "Could not destroy $deploy_id"
        exit 1
    fi

    # Compact memory
    if [ "x$CLEANUP_MEMORY_ON_STOP" = "xyes" ]; then
        sudo -n sysctl vm.drop_caches=3 vm.compact_memory=1 &>/dev/null &
    fi

fi